/*
Electronic Tap Handle

 This will display a beer name, ABV and brief
 description on an OLED display with a SSD1306
 chipset.  If using a differnet display make the 
 appropriate changes.

 The core component is a WEMOS D1 mini, but any
 wifi enabled esp8266 board should work with the 
 appropriate changes.

 This allows the tap handle to connect to a main
 wireless network so it can be updated while on 
 the home network.  It also sets up the tap
 handle as a wireless AP that can be connected 
 to away from the home network with the appropriate
 SSID, Password and IP settings.

 LIMITATIONS/ISSUES:
 When the tap handle info is submitted on the web 
 page it resets the connection and you have to 
 hit the "back" button to reload the main page.
 I have not found an easy solution to that :)
 The second input is an ABV with ABV and the "%"
 hard coded in. 
 If you have a beer name that is longer than 10 
 Characters you can type more than 10 characters
 on the "beer" line and the text will wrap to the 
 second line.

This was cobbled together by a non programmer
from various examples on the web.  It is not 
pretty but it mostly gets the job done.

No doubt there are better ways of doing much of 
this, but it kinda works.  Good Luck.

7/5/20
ElectronicTapHandles@gmail.com
Jay

 */
 
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <ESP8266WebServer.h>
#include <ESP8266WiFi.h>
#include <WiFiClient.h>

//enter in your network WIFI name here KEEP THE QOUTES
#define wifi_ssid "yournetworkname"
//enter in your network password here KEEP THE QUOTES
#define wifi_password "yourpassword"
// tap handle is the number of the tap handle
#define taphandle 1
// iplastoct is the last oct of your FIXED IP address for the tap handle  I use 200 + the tap handle number
// so the address of the 1st one is 192.168.1.201 and the fifth one is 192.168.1.205
#define iplastoct 200 + taphandle
 
// SCL GPIO5 Wemos D1 MINI pin D1 
// SDA GPIO4 Wemos D1 MINI pin D2
#define OLED_RESET 0  // GPIO0  THIS MAY BE DIFFERNET FOR YOUR DISPLAY
Adafruit_SSD1306 display(OLED_RESET);


//set up as web server port 80 (normal http port)
ESP8266WebServer server ( 80 );
char htmlResponse[3200];  //set up the size of the html response buffer

//web page routine  Root of the web page '/'
void handleRoot() {

//this is just a HUGH text file from here to the "server.send " command.  This is the html for the root web page.
  snprintf ( htmlResponse, 3200,
"<!DOCTYPE html>\
<html lang=\"en\">\
  <head>\
    <meta charset=\"utf-8\">\
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">\
  </head>\
  <body>\
          <h1>Tap Handle 02</h1>\
  <form action='\save' method='post'>\
    <label for='beer'>Beer Name:</label><br>\
    <input type='text' id='beer' name='beer' maxlength=20 size='10'>\
    <input type='radio' id='beertextsize3' name='beertextsize' value='3'>\
    <label for='beertextsize3'>Large (7)</label>\
    <input type='radio' id='beertextsize2' name='beertextsize' value='2' checked>\
    <label for='beertextsize2'>Medium (10)</label><br>\
    <label for='abv'>ABV:</label><br>\
    <input type='text' id='abv' name='abv' maxlength=4>\
    <input type='radio' id='abvtextsize2' name='abvtextsize' value='2' checked>\
    <label for='abvtextsize2'>Medium</label>\
    <input type='radio' id='abvtextsize1' name='abvtextsize' value='1'>\
    <label for='abvtextsize1'>Small</label><br>\
    <label for='line1'>Description1:</label><br>\
    <input type='text' id='line1' name='line1' maxlength=21>\
    <input type='radio' id='line1textsize2' name='line1textsize' value='2'>\
    <label for='line1textsize2'>Medium</label>\
    <input type='radio' id='line1textsize1' name='line1textsize' value='1' checked>\
    <label for='line1textsize1'>Small</label><br>\
    <label for='line2'>Description2:</label><br>\
    <input type='text' id='line2' name='line2' maxlength=21>\
    <input type='radio' id='line2textsize2' name='line2textsize' value='2'>\
    <label for='line2textsize2'>Medium</label>\
    <input type='radio' id='line2textsize1' name='line2textsize' value='1' checked>\
    <label for='line2textsize1'>Small</label><br>\
    <label for='line3'>Description3:</label><br>\
    <input type='text' id='line3' name='line3' maxlength=21>\
    <input type='radio' id='line3textsize2' name='line3textsize' value='2'>\
    <label for='line3textsize2'>Medium</label>\
    <input type='radio' id='line3textsize1' name='line3textsize' value='1' checked>\
    <label for='line3textsize1'>Small</label><br>\
    <label for='line4'>Description4:</label><br>\
    <input type='text' id='line4' name='line4' maxlength=21>\
    <input type='radio' id='line4textsize2' name='line4textsize' value='2'>\
    <label for='line4textsize2'>Medium</label>\
    <input type='radio' id='line4textsize1' name='line4textsize' value='1' checked>\
    <label for='line1textsize4'>Small</label><br><br><br>\
    <input type='submit' value='Submit'>\
  </form>\
    </body>\
  </html>"); 
    server.send ( 200, "text/html", htmlResponse );  

}

//save the input from the web - '/save' of the web page?
void handleSave() {
    if (server.arg("beer")!= ""){
    Serial.println("Beer Name: " + server.arg("beer"));
 
  }

  if (server.arg("abv")!= ""){
    Serial.println("abv: " + server.arg("abv"));
  }

  if (server.arg("line1")!= ""){
    Serial.println("Line1: " + server.arg("line1"));
  }
  
  if (server.arg("line2")!= ""){
    Serial.println("Line2: " + server.arg("line2"));
  }
  
  if (server.arg("line3")!= ""){
    Serial.println("Line3: " + server.arg("line3"));
  }

  if (server.arg("line4")!= ""){
    Serial.println("Line4: " + server.arg("line4"));
  }
  
 }

void setup()   {
  Serial.begin(115200);
//the soft AP SSID and password are wireless network and password (AGAIN, KEEP THE QOUTES) you will use to connect directly to the tap handle when it is not on "your" network, beerfests, friends house, whatever.
WiFi.softAP("SOFT-SSID", "PASSWORD");  
WiFi.begin(wifi_ssid,wifi_password);
//This IP is the static IP for the tap handle on the "home" network.  The iplastoct variable is calculated from the "base" number (in the original here 200) and the tap handle number
IPAddress ip(192,168,1,iplastoct);   
//This IP is the static IP for the tap handle on the "home" network.  The iplastoct variable is calculated from the "base" number (in the original here 200) and the tap handle number
//The IP for the AP (Access Point) must be on a different subnet than the main network (ONE of first three numbers before the "iplastoct" must be different than the "home" network, in this case 4 instead of 1)
IPAddress ap_ip(192,168,4,iplastoct);
IPAddress gateway(192,168,1,1); 
The IP for the AP (Access Point) must be on a different subnet than the main network (ONE of first three numbers before the "iplastoct" must be different than the "home" network, in this case 4 instead of 1)
IPAddress ap_gateway(192,168,4,1); 
  
IPAddress subnet(255,255,255,0);  
WiFi.config(ip, gateway, subnet);
 Serial.print("Setting soft-AP configuration ... ");
Serial.println(WiFi.softAPConfig(ap_ip, ap_gateway, subnet) ? "Ready" : "Failed!");

  Serial.print("Setting soft-AP ... ");
  //the "SOFT-SSID" and the "SOFT-PASSWORD" MUST BE the SAME as above
Serial.println(WiFi.softAP("SOFT-SSID", "PASSWORD") ? "Ready" : "Failed!");

  Serial.print("Soft-AP IP address = ");
  Serial.println(WiFi.softAPIP());
  
 //start the web server?
 server.on ( "/", handleRoot );
  server.on ("/save", handleSave);

  server.begin();
  Serial.println ( "HTTP server started" );


 //the I2C address below (0X3c) MAY be different for your display.
 display.begin(SSD1306_SWITCHCAPVCC, 0x3c);  // initialize with the I2C addr 0x3C (for the 64x48)
  // init done
 
  display.display();
  delay(2000);
   //set up variables
 
}
 
 
void loop() {
  server.handleClient(); //Handles incoming server requests
  // Clear the buffer.
int beertextsize = server.arg("beertextsize").toInt();
String beer = server.arg("beer");
int abvtextsize = server.arg("abvtextsize").toInt();
String abv = server.arg("abv") + char(37) + " ABV";
int line1textsize = server.arg("line1textsize").toInt();
String line1 = server.arg("line1");
int line2textsize = server.arg("line2textsize").toInt();
String line2 = server.arg("line2");
int line3textsize = server.arg("line3textsize").toInt();
String line3 = server.arg("line3");
int line4textsize = server.arg("line4textsize").toInt();
String line4 = server.arg("line4");
  display.clearDisplay();
 
  // text display tests
  display.setTextSize(beertextsize);
  display.setTextColor(WHITE);
  display.setCursor(0,0);
  display.println(beer);
  display.setTextSize(abvtextsize);
  display.println(abv);
  display.setTextSize(line1textsize);
  display.println(line1);
  display.setTextSize(line2textsize);
  display.println(line2);
  display.setTextSize(line3textsize);
  display.println(line3);
  display.setTextSize(line4textsize);
  display.println(line4);
  display.display();

  Serial.printf("Stations connected = %d\n", WiFi.softAPgetStationNum());
  delay(3000);
}
